function init() {
	tinyMCEPopup.resizeToInnerSize();
}

function isValidUrl( url )
{
	var regexp = /(http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/
	return regexp.test(url);
}

function getYouTubeLink( url ) 
{	
	// check if this is a URL pointing to a youtube link or to a youtube video
	if( url.substring( 0, 31 ) == "http://www.youtube.com/watch?v=" ) {
		// and if it's a link to a normal youtube page, build the right link to the video player	
		var regexp = /http:\/\/www.youtube.com\/.*?v=([\-0-9a-zA-z]*).*/i;
		result = regexp.exec( url );
		if( result ) {
			videoId = result[1];
		}
		else {
			// let's try to make a best guess...
			videoId = url.substring( 31, url.length );
		}
		
		url = "http://www.youtube.com/v/" + videoId;
	}
	return( url );
}

function getGoogleVideoLink( url )
{
	// check if it's a link to a video page or a link to the video player
	if( url.substring( 0, 40 ) == "http://video.google.com/videoplay?docid=" ) {
		// if it's a link to a video page, generate the right one
		var regexp = /http:\/\/video.google.com\/.*?docid=([\-0-9a-zA-z]*).*/i;
		result = regexp.exec( url );
		if( result ) {
			videoId = result[1];
		}
		else {		
			videoId = url.substring( 40, url.length );
		}
		
		url = "http://video.google.com/googleplayer.swf?docId=" + videoId;
	}
	
	return( url );
}

function insertVideoCode()
{
	// get and check the URL
	urlField = document.forms[0].url;
	url = urlField.value;
	if( url == "" || !isValidUrl( url )) {
		window.alert( "The URL is not valid" );
		return( false );
	}
	
	// check if a destination system was selected
	youtube = document.getElementById("youtube");
	gvideo = document.getElementById("gvideo");
	if( youtube.checked==false && gvideo.checked==false) {
		window.alert( "You must select one of the video services" );
		return( false );	
	}
	
	if( youtube.checked == true ) {
		link = getYouTubeLink( url );
		css="ltVideoYouTube";
		width=425;
		height=350;
	}
	else {
		link = getGoogleVideoLink( url );	
		css="ltVideoGoogleVideo";
		width=400;
		height=326;		
	}

	insertFlash( link, css, width, height );
}

function insertFlash( file, css, width, height ) {

	var html      = '';

	html += ''
		+ '<img src="' + (tinyMCE.getParam("theme_href") + "/images/spacer.gif") + '" mce_src="' + (tinyMCE.getParam("theme_href") + "/images/spacer.gif") + '" '
		+ 'width="' + width + '" height="' + height + '" '
		+ 'border="0" alt="' + file + '" title="' + file + '" class="'+css+'" />';

	tinyMCEPopup.execCommand("mceInsertContent", true, html);
	tinyMCE.selectedInstance.repaint();

	tinyMCEPopup.close();
}